/* support.h
 *
 * Copyright (C) 2017, 2020 Timothy Richard Musson
 *
 * Email: Tim Musson <trmusson@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */


#ifndef HAVE_SUPPORT_H
#define HAVE_SUPPORT_H

#include "memory.h"
#include "video.h"


#define LETTERS_UPPER   "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
#define LETTERS_LOWER   "abcdefghijklmnopqrstuvwxyz"
#define LETTERS         LETTERS_UPPER LETTERS_LOWER
#define DIGITS          "0123456789"
#define DIGITS_HEX      "0123456789ABCDEFabcdef"
#define LABEL_PROFILE   LETTERS DIGITS "_"


int      parse_ascii_integer (const char *s);
xbool_t  parse_ascii_bool (const char *s);
xbool_t  str_contains_char (const char *s, char c);
xbool_t  str_valid (const char *s, const char *legal_chars);
xbool_t  parse_cpu_type (const char *s, int *type);
xbool_t  parse_environment (const char *s, int *type);
xbool_t  parse_keyboard_type (const char *s, int *type);
xbool_t  parse_video_rgb (const char *s, Byte *red, Byte *green, Byte *blue);
char*    parse_fname_plus_offset (const char *s, int *offset);
char*    path_to_file (const char *dirname, const char *basename,
                       const char *fname);
int      load_hex (const char *progname, const char *fname, Memory *memory,
                   int offset);


#endif

