/* xgetopt.h - simple and getopt_long alternative
 *
 * Copyright (C) 2013, 2020 Timothy Richard Musson
 *
 * Email: Tim Musson <trmusson@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#ifndef HAVE_XGETOPT_H
#define HAVE_XGETOPT_H

#define XGETOPT_MISSING_ARG      -3
#define XGETOPT_UNKNOWN          -2
#define XGETOPT_NONE             -1


struct _XGetOption {
	int     min_len;
	xbool_t requires_arg;
	char    *opt_str;
};

typedef struct  _XGetOption XGetOption;

int             xgetopt (int argc, char *argv[], int *idx,
                         XGetOption *option, int n_options);

#endif /* HAVE_XGETOPT_H */

