/* xstr.h
 *
 * Copyright (C) 2005, 2011, 2017, 2020 Timothy Richard Musson
 *
 * Email: Tim Musson <trmusson@gmail.com>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 *
 */

#ifndef XSTR_H
#define XSTR_H


#define XSTR_SPLIT_GROW_SIZE    255

char*  xstr_nfill (size_t len, char c);

char*  xstr_dup (const char *str);
char*  xstr_dup_toupper (const char *str);
char*  xstr_dup_tolower (const char *str);
char*  xstr_ndup (const char *str, size_t n);

xbool_t xstr_has_prefix (const char *str, const char *prefix);
xbool_t xstr_has_suffix (const char *str, const char *suffix);

char*  xstr_chug (char *str);
char*  xstr_chomp (char *str);
char*  xstr_strip (char *str);

char*  xstr_replace (const char *str, const char *f, const char *r, int max);

char*  xstr_concat (const char *str, ...);
char*  xstr_concatv (char **array);
char*  xstr_join (const char *separator, ...);
char*  xstr_joinv (const char *separator, char **array);

char** xstr_split (const char *str, const char *delim);
void   xstr_freev (char **array);

char*  xstr_dup_printf (const char *fmt, ...);


#endif /* XSTR_H */

