
; Some BCD and carry-flag examples/tests from
; http://www.6502.org/tutorials/decimal_mode.html


        CLD      ; Binary mode (binary addition: 88 + 70 + 1 = 159)
        SEC      ; Note: carry is set, not clear!
        LDA #$58 ; 88
        ADC #$46 ; 70 (after this instruction, C = 0, A = $9F = 159)
        BRK

        SED      ; Decimal mode (BCD addition: 58 + 46 + 1 = 105)
        SEC      ; Note: carry is set, not clear!
        LDA #$58
        ADC #$46 ; After this instruction, C = 1, A = $05
        BRK
        
        SED      ; Decimal mode (BCD addition: 12 + 34 = 46)
        CLC
        LDA #$12
        ADC #$34 ; After this instruction, C = 0, A = $46
        BRK

        SED      ; Decimal mode (BCD addition: 15 + 26 = 41)
        CLC
        LDA #$15
        ADC #$26 ; After this instruction, C = 0, A = $41
        BRK

        SED      ; Decimal mode (BCD addition: 81 + 92 = 173)
        CLC
        LDA #$81
        ADC #$92 ; After this instruction, C = 1, A = $73
        BRK

        SED      ; Decimal mode (BCD subtraction: 46 - 12 = 34)
        SEC
        LDA #$46
        SBC #$12 ; After this instruction, C = 1, A = $34)
        BRK

        SED      ; Decimal mode (BCD subtraction: 40 - 13 = 27)
        SEC
        LDA #$40
        SBC #$13 ; After this instruction, C = 1, A = $27)
        BRK

        SED      ; Decimal mode (BCD subtraction: 32 - 2 - 1 = 29)
        CLC      ; Note: carry is clear, not set!
        LDA #$32
        SBC #$02 ; After this instruction, C = 1, A = $29)
        BRK

; ----------

        SED      ; Decimal mode (BCD subtraction: 12 - 21)
        SEC
        LDA #$12
        SBC #$21 ; After this instruction, C = 0, A = $91)
        BRK

        SED      ; Decimal mode (BCD subtraction: 21 - 34)
        SEC
        LDA #$21
        SBC #$34 ; After this instruction, C = 0, A = $87)
        BRK

; ----------

        SED      ; Decimal mode
        CLC
        LDA #$90
        ADC #$90 ; V flag will now be set on a 6502, 65C02, and 65816
        BRK

        SED      ; Decimal mode
        SEC
        LDA #$01
        SBC #$01 ; Now A = $00, Z = 1 (on a 6502, 65C02, 65816)
        BRK

        SED      ; Decimal mode
        CLC
        LDA #$99
        ADC #$01 ; Now A = $00, Z = 0 (on a 6502, but Z =1 on a 65C02 or 65816)
        BRK

        RTS


